<!DOCTYPE html>
<html>
<head>
    <script>
      function connect()
      {
        let log = message =>
            document.getElementById("messages").value +=
                "[" + new Date().toTimeString().substring(0, 8) + "] " + message + "\n";
        let ws = new WebSocket("ws://localhost:8080/data");
        ws.onopen = () => {
          document.getElementById("input").onkeyup =
            e => ws.send(e.key);
          log("WS connection opened");
        };
        ws.onclose =
          event => {
            log("WS connection closed with code: " + event.code);
            connect();
          }
        ws.onmessage = event => log("WS received: " + event.data);
      }
      connect();

    </script>
</head>
<body>
<textarea name="messages" id="messages" cols="50" rows="30"></textarea>
<textarea name="input" id="input" cols="50" rows="30"></textarea>

</body>
</html>